<center><a href="slo.c">Actual source code: slo.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:27:15+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/* slo.f -- translated by f2c (version of 25 March 1992  12:58:56).*/</font>

<a name="line5"> 5: </a> #include <A href="../../../include/petsc.h.html">petsc.h</A>
<a name="line6"> 6: </a> #include <A href="../../../src/mat/color/color.h.html">src/mat/color/color.h</A>

<a name="line10"> 10: </a><strong><font color="#4169E1"><a name="MINPACKslo"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MINPACKslo(<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * indrow,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * jpntr,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * indcol, <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ipntr, <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ndeg,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * list,</font></strong>
<a name="line11"> 11: </a><strong><font color="#4169E1">                          <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * maxclq,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *iwa1,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * iwa2,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * iwa3,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * iwa4)</font></strong>
<a name="line12"> 12: </a>{
<a name="line13"> 13: </a>    <font color="#B22222">/* System generated locals */</font>
<a name="line14"> 14: </a>    <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i__1, i__2, i__3, i__4;

<a name="line16"> 16: </a>    <font color="#B22222">/* Local variables */</font>
<a name="line17"> 17: </a>    <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> jcol, ic, ip, jp, ir, mindeg, numdeg, numord;

<a name="line19"> 19: </a><font color="#B22222">/*     Given the sparsity pattern of an m by n matrix A, this */</font>
<a name="line20"> 20: </a><font color="#B22222">/*     subroutine determines the smallest-last ordering of the */</font>
<a name="line21"> 21: </a><font color="#B22222">/*     columns of A. */</font>
<a name="line22"> 22: </a><font color="#B22222">/*     The smallest-last ordering is defined for the loopless */</font>
<a name="line23"> 23: </a><font color="#B22222">/*     graph G with vertices a(j), j = 1,2,...,n where a(j) is the */</font>
<a name="line24"> 24: </a><font color="#B22222">/*     j-th column of A and with edge (a(i),a(j)) if and only if */</font>
<a name="line25"> 25: </a><font color="#B22222">/*     columns i and j have a non-zero in the same row position. */</font>
<a name="line26"> 26: </a><font color="#B22222">/*     The smallest-last ordering is determined recursively by */</font>
<a name="line27"> 27: </a><font color="#B22222">/*     letting list(k), k = n,...,1 be a column with least degree */</font>
<a name="line28"> 28: </a><font color="#B22222">/*     in the subgraph spanned by the un-ordered columns. */</font>
<a name="line29"> 29: </a><font color="#B22222">/*     Note that the value of m is not needed by slo and is */</font>
<a name="line30"> 30: </a><font color="#B22222">/*     therefore not present in the subroutine statement. */</font>
<a name="line31"> 31: </a><font color="#B22222">/*     The subroutine statement is */</font>
<a name="line32"> 32: </a><font color="#B22222">/*       subroutine slo(n,indrow,jpntr,indcol,ipntr,ndeg,list, */</font>
<a name="line33"> 33: </a><font color="#B22222">/*                      maxclq,iwa1,iwa2,iwa3,iwa4) */</font>
<a name="line34"> 34: </a><font color="#B22222">/*     where */</font>
<a name="line35"> 35: </a><font color="#B22222">/*       n is a positive integer input variable set to the number */</font>
<a name="line36"> 36: </a><font color="#B22222">/*         of columns of A. */</font>
<a name="line37"> 37: </a><font color="#B22222">/*       indrow is an integer input array which contains the row */</font>
<a name="line38"> 38: </a><font color="#B22222">/*         indices for the non-zeroes in the matrix A. */</font>
<a name="line39"> 39: </a><font color="#B22222">/*       jpntr is an integer input array of length n + 1 which */</font>
<a name="line40"> 40: </a><font color="#B22222">/*         specifies the locations of the row indices in indrow. */</font>
<a name="line41"> 41: </a><font color="#B22222">/*         The row indices for column j are */</font>
<a name="line42"> 42: </a><font color="#B22222">/*               indrow(k), k = jpntr(j),...,jpntr(j+1)-1. */</font>
<a name="line43"> 43: </a><font color="#B22222">/*         Note that jpntr(n+1)-1 is then the number of non-zero */</font>
<a name="line44"> 44: </a><font color="#B22222">/*         elements of the matrix A. */</font>
<a name="line45"> 45: </a><font color="#B22222">/*       indcol is an integer input array which contains the */</font>
<a name="line46"> 46: </a><font color="#B22222">/*         column indices for the non-zeroes in the matrix A. */</font>
<a name="line47"> 47: </a><font color="#B22222">/*       ipntr is an integer input array of length m + 1 which */</font>
<a name="line48"> 48: </a><font color="#B22222">/*         specifies the locations of the column indices in indcol. */</font>
<a name="line49"> 49: </a><font color="#B22222">/*         The column indices for row i are */</font>
<a name="line50"> 50: </a><font color="#B22222">/*               indcol(k), k = ipntr(i),...,ipntr(i+1)-1. */</font>
<a name="line51"> 51: </a><font color="#B22222">/*         Note that ipntr(m+1)-1 is then the number of non-zero */</font>
<a name="line52"> 52: </a><font color="#B22222">/*         elements of the matrix A. */</font>
<a name="line53"> 53: </a><font color="#B22222">/*       ndeg is an integer input array of length n which specifies */</font>
<a name="line54"> 54: </a><font color="#B22222">/*         the degree sequence. The degree of the j-th column */</font>
<a name="line55"> 55: </a><font color="#B22222">/*         of A is ndeg(j). */</font>
<a name="line56"> 56: </a><font color="#B22222">/*       list is an integer output array of length n which specifies */</font>
<a name="line57"> 57: </a><font color="#B22222">/*         the smallest-last ordering of the columns of A. The j-th */</font>
<a name="line58"> 58: </a><font color="#B22222">/*         column in this order is list(j). */</font>
<a name="line59"> 59: </a><font color="#B22222">/*       maxclq is an integer output variable set to the <A href="../../../docs/manualpages/Sys/size.html#size">size</A> */</font>
<a name="line60"> 60: </a><font color="#B22222">/*         of the largest clique found during the ordering. */</font>
<a name="line61"> 61: </a><font color="#B22222">/*       iwa1,iwa2,iwa3, and iwa4 are integer work arrays of length n. */</font>
<a name="line62"> 62: </a><font color="#B22222">/*     Subprograms called */</font>
<a name="line63"> 63: </a><font color="#B22222">/*       FORTRAN-supplied ... min */</font>
<a name="line64"> 64: </a><font color="#B22222">/*     Argonne National Laboratory. MINPACK Project. August 1984. */</font>
<a name="line65"> 65: </a><font color="#B22222">/*     Thomas F. Coleman, Burton S. Garbow, Jorge J. More' */</font>

<a name="line68"> 68: </a>    <font color="#B22222">/* Parameter adjustments */</font>
<a name="line69"> 69: </a>    --iwa4;
<a name="line70"> 70: </a>    --iwa3;
<a name="line71"> 71: </a>    --iwa2;
<a name="line72"> 72: </a>    --list;
<a name="line73"> 73: </a>    --ndeg;
<a name="line74"> 74: </a>    --ipntr;
<a name="line75"> 75: </a>    --indcol;
<a name="line76"> 76: </a>    --jpntr;
<a name="line77"> 77: </a>    --indrow;

<a name="line79"> 79: </a>    <font color="#B22222">/* Function Body */</font>
<a name="line80"> 80: </a>    mindeg = *n;
<a name="line81"> 81: </a>    i__1 = *n;
<a name="line82"> 82: </a>    <font color="#4169E1">for</font> (jp = 1; jp &lt;= i__1; ++jp) {
<a name="line83"> 83: </a>        iwa1[jp - 1] = 0;
<a name="line84"> 84: </a>        iwa4[jp] = *n;
<a name="line85"> 85: </a>        list[jp] = ndeg[jp];
<a name="line86"> 86: </a>        <font color="#B22222">/* Computing MIN */</font>
<a name="line87"> 87: </a>        i__2 = mindeg, i__3 = ndeg[jp];
<a name="line88"> 88: </a>        mindeg = <A href="../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(i__2,i__3);
<a name="line89"> 89: </a>    }

<a name="line91"> 91: </a>    <font color="#B22222">/*     Create a doubly-linked list to access the degrees of the */</font>
<a name="line92"> 92: </a>    <font color="#B22222">/*     columns. The pointers for the linked list are as follows. */</font>

<a name="line94"> 94: </a>    <font color="#B22222">/*     Each un-ordered column ic is in a list (the degree list) */</font>
<a name="line95"> 95: </a>    <font color="#B22222">/*     of columns with the same degree. */</font>

<a name="line97"> 97: </a>    <font color="#B22222">/*     iwa1(numdeg) is the first column in the numdeg list */</font>
<a name="line98"> 98: </a>    <font color="#B22222">/*     unless iwa1(numdeg) = 0. In this case there are */</font>
<a name="line99"> 99: </a>    <font color="#B22222">/*     no columns in the numdeg list. */</font>

<a name="line101">101: </a>    <font color="#B22222">/*     iwa2(ic) is the column before ic in the degree list */</font>
<a name="line102">102: </a>    <font color="#B22222">/*     unless iwa2(ic) = 0. In this case ic is the first */</font>
<a name="line103">103: </a>    <font color="#B22222">/*     column in this degree list. */</font>

<a name="line105">105: </a>    <font color="#B22222">/*     iwa3(ic) is the column after ic in the degree list */</font>
<a name="line106">106: </a>    <font color="#B22222">/*     unless iwa3(ic) = 0. In this case ic is the last */</font>
<a name="line107">107: </a>    <font color="#B22222">/*     column in this degree list. */</font>

<a name="line109">109: </a>    <font color="#B22222">/*     If ic is an un-ordered column, then list(ic) is the */</font>
<a name="line110">110: </a>    <font color="#B22222">/*     degree of ic in the graph induced by the un-ordered */</font>
<a name="line111">111: </a>    <font color="#B22222">/*     columns. If jcol is an ordered column, then list(jcol) */</font>
<a name="line112">112: </a>    <font color="#B22222">/*     is the smallest-last order of column jcol. */</font>

<a name="line114">114: </a>    i__1 = *n;
<a name="line115">115: </a>    <font color="#4169E1">for</font> (jp = 1; jp &lt;= i__1; ++jp) {
<a name="line116">116: </a>        numdeg = ndeg[jp];
<a name="line117">117: </a>        iwa2[jp] = 0;
<a name="line118">118: </a>        iwa3[jp] = iwa1[numdeg];
<a name="line119">119: </a>        <font color="#4169E1">if</font> (iwa1[numdeg] &gt; 0) {
<a name="line120">120: </a>            iwa2[iwa1[numdeg]] = jp;
<a name="line121">121: </a>        }
<a name="line122">122: </a>        iwa1[numdeg] = jp;
<a name="line123">123: </a>    }
<a name="line124">124: </a>    *maxclq = 0;
<a name="line125">125: </a>    numord = *n;

<a name="line127">127: </a>    <font color="#B22222">/*     Beginning of iteration loop. */</font>

<a name="line129">129: </a><strong><font color="#FF0000">L30:</font></strong>

<a name="line131">131: </a>    <font color="#B22222">/*        Choose a column jcol of minimal degree mindeg. */</font>

<a name="line133">133: </a><strong><font color="#FF0000">L40:</font></strong>
<a name="line134">134: </a>    jcol = iwa1[mindeg];
<a name="line135">135: </a>    <font color="#4169E1">if</font> (jcol &gt; 0) {
<a name="line136">136: </a>        <font color="#4169E1">goto</font> L50;
<a name="line137">137: </a>    }
<a name="line138">138: </a>    ++mindeg;
<a name="line139">139: </a>    <font color="#4169E1">goto</font> L40;
<a name="line140">140: </a><strong><font color="#FF0000">L50:</font></strong>
<a name="line141">141: </a>    list[jcol] = numord;

<a name="line143">143: </a>    <font color="#B22222">/*        Mark the <A href="../../../docs/manualpages/Sys/size.html#size">size</A> of the largest clique */</font>
<a name="line144">144: </a>    <font color="#B22222">/*        found during the ordering. */</font>

<a name="line146">146: </a>    <font color="#4169E1">if</font> (mindeg + 1 == numord &amp;&amp; !*maxclq) {
<a name="line147">147: </a>        *maxclq = numord;
<a name="line148">148: </a>    }

<a name="line150">150: </a>    <font color="#B22222">/*        Termination test. */</font>

<a name="line152">152: </a>    --numord;
<a name="line153">153: </a>    <font color="#4169E1">if</font> (!numord) {
<a name="line154">154: </a>        <font color="#4169E1">goto</font> L80;
<a name="line155">155: </a>    }

<a name="line157">157: </a>    <font color="#B22222">/*        Delete column jcol from the mindeg list. */</font>

<a name="line159">159: </a>    iwa1[mindeg] = iwa3[jcol];
<a name="line160">160: </a>    <font color="#4169E1">if</font> (iwa3[jcol] &gt; 0) {
<a name="line161">161: </a>        iwa2[iwa3[jcol]] = 0;
<a name="line162">162: </a>    }

<a name="line164">164: </a>    <font color="#B22222">/*        Find all columns adjacent to column jcol. */</font>

<a name="line166">166: </a>    iwa4[jcol] = 0;

<a name="line168">168: </a>    <font color="#B22222">/*        Determine all positions (ir,jcol) which correspond */</font>
<a name="line169">169: </a>    <font color="#B22222">/*        to non-zeroes in the matrix. */</font>

<a name="line171">171: </a>    i__1 = jpntr[jcol + 1] - 1;
<a name="line172">172: </a>    <font color="#4169E1">for</font> (jp = jpntr[jcol]; jp &lt;= i__1; ++jp) {
<a name="line173">173: </a>        ir = indrow[jp];

<a name="line175">175: </a>        <font color="#B22222">/*           For each row ir, determine all positions (ir,ic) */</font>
<a name="line176">176: </a>        <font color="#B22222">/*           which correspond to non-zeroes in the matrix. */</font>

<a name="line178">178: </a>        i__2 = ipntr[ir + 1] - 1;
<a name="line179">179: </a>        <font color="#4169E1">for</font> (ip = ipntr[ir]; ip &lt;= i__2; ++ip) {
<a name="line180">180: </a>            ic = indcol[ip];

<a name="line182">182: </a>            <font color="#B22222">/*              Array iwa4 marks columns which are adjacent to */</font>
<a name="line183">183: </a>            <font color="#B22222">/*              column jcol. */</font>

<a name="line185">185: </a>            <font color="#4169E1">if</font> (iwa4[ic] &gt; numord) {
<a name="line186">186: </a>                iwa4[ic] = numord;

<a name="line188">188: </a>                <font color="#B22222">/*                 Update the pointers to the current degree lists. */</font>

<a name="line190">190: </a>                numdeg = list[ic];
<a name="line191">191: </a>                --list[ic];
<a name="line192">192: </a>                <font color="#B22222">/* Computing MIN */</font>
<a name="line193">193: </a>                i__3 = mindeg, i__4 = list[ic];
<a name="line194">194: </a>                mindeg = <A href="../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(i__3,i__4);

<a name="line196">196: </a>                <font color="#B22222">/*                 Delete column ic from the numdeg list. */</font>

<a name="line198">198: </a>                <font color="#4169E1">if</font> (!iwa2[ic]) {
<a name="line199">199: </a>                    iwa1[numdeg] = iwa3[ic];
<a name="line200">200: </a>                } <font color="#4169E1">else</font> {
<a name="line201">201: </a>                    iwa3[iwa2[ic]] = iwa3[ic];
<a name="line202">202: </a>                }
<a name="line203">203: </a>                <font color="#4169E1">if</font> (iwa3[ic] &gt; 0) {
<a name="line204">204: </a>                    iwa2[iwa3[ic]] = iwa2[ic];
<a name="line205">205: </a>                }

<a name="line207">207: </a>                <font color="#B22222">/*                 Add column ic to the numdeg-1 list. */</font>

<a name="line209">209: </a>                iwa2[ic] = 0;
<a name="line210">210: </a>                iwa3[ic] = iwa1[numdeg - 1];
<a name="line211">211: </a>                <font color="#4169E1">if</font> (iwa1[numdeg - 1] &gt; 0) {
<a name="line212">212: </a>                    iwa2[iwa1[numdeg - 1]] = ic;
<a name="line213">213: </a>                }
<a name="line214">214: </a>                iwa1[numdeg - 1] = ic;
<a name="line215">215: </a>            }
<a name="line216">216: </a>        }
<a name="line217">217: </a>    }

<a name="line219">219: </a>    <font color="#B22222">/*        End of iteration loop. */</font>

<a name="line221">221: </a>    <font color="#4169E1">goto</font> L30;
<a name="line222">222: </a><strong><font color="#FF0000">L80:</font></strong>

<a name="line224">224: </a>    <font color="#B22222">/*     Invert the array list. */</font>

<a name="line226">226: </a>    i__1 = *n;
<a name="line227">227: </a>    <font color="#4169E1">for</font> (jcol = 1; jcol &lt;= i__1; ++jcol) {
<a name="line228">228: </a>        iwa2[list[jcol]] = jcol;
<a name="line229">229: </a>    }
<a name="line230">230: </a>    i__1 = *n;
<a name="line231">231: </a>    <font color="#4169E1">for</font> (jp = 1; jp &lt;= i__1; ++jp) {
<a name="line232">232: </a>        list[jp] = iwa2[jp];
<a name="line233">233: </a>    }
<a name="line234">234: </a>    <font color="#4169E1">return</font>(0);
<a name="line235">235: </a>}

</pre>
</body>

</html>
